config/routes.rb
Rails.application.routes.draw do

  root to: 'events#index'

  resources :events,       only: [:index, :show, :update]
  resources :meta_events,  only: [:index, :new, :create, :edit, :update]
  resources :room_prices,  only: [:index, :new, :create, :edit, :update] # fixme - update?
  resources :rooms,        only: [:index, :new, :create, :show, :edit, :update]
  resources :bands,        only: [:index, :new, :create, :show, :edit, :update]
  resources :musicians,    only: [:index, :new, :create, :show, :edit, :update]

end

app/models/event.rb
class Event < ActiveRecord::Base
  has_one :meta_event

  scope :specified_virtual_date, ->(date)       { where('virtual_date = ?', date) }
  scope :specified_dates,        ->(dates)      { where('virtual_date IN (?)', dates) }
  scope :start_time_limit,       ->(start_time) { where('start_time >= ?', start_time) }
  scope :end_date_limit,         ->(end_date)   { where('end_date >= ?', end_date) }
  scope :cancelled,              ->             { where('cancelled IS NULL') }
  scope :not_cancelled,          ->             { where('cancelled IS NOT NULL') }
  scope :specified_room,         ->(room_id)    { where( room_id: room_id) }

  validates :start_date, :end_date, :start_time, :end_time, :virtual_date, :meta_event_id, presence: true
  validate :overrides_event, :date_chronology, :time_chronology

  # devuelve true cuando se superpone con otra
  def overrides_event

    another_events = self.getOverrideEvents

    return true if another_events.nil?

    self.errors[:base] << "Existe al menos otro evento registrado en ese dia/horario."
    return false

  end

  def date_chronology
    return true if self.start_date < self.end_date

    self.errors[:base] << "Los dias ingresados no son correctos."
    return false
  end

  def time_chronology
    return true if self.start_time < self.end_time

    self.errors[:base] << "Los horarios ingresados no son correctos."
    return false
  end

  def self.GetAgendaEvents(date)
    Event.specified_virtual_date( args.virtual_date ).not_cancelled()
  end

  def getOverrideEvents()
    dates = (self.start_date..self.end_date)
    room_id = self.meta_event.room_id
    scope = Event.specified_room( room_id )
                 .specified_dates( dates )
                 .not_cancelled()
                 .start_time_limit( self.start_time )
                 .end_time_limit( self.end_time )

    scope.exclude_event_id( self.event_id ) if self.event_id

    return scope
  end

end

app/controllers/events_controller.rb
class EventsController < ApplicationController
  before_action :set_event, only: [:show, :edit, :update, :destroy]

  # GET /events
  # GET /events.json
  def index
    virtual_date = date_param || Date.today
    @events = Event.GetAgendaEvents( virtual_date )
  end

  # GET /events/1
  # GET /events/1.json
  def show
  end

  # GET /events/new
  def new
    @event = Event.new
  end

  # GET /events/1/edit
  def edit
  end

  # POST /events
  # POST /events.json
  def create
    @event = Event.new(event_params)

    respond_to do |format|
      if @event.save
        format.html { redirect_to @event, notice: 'Event was successfully created.' }
        format.json { render :show, status: :created, location: @event }
      else
        format.html { render :new }
        format.json { render json: @event.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /events/1
  # PATCH/PUT /events/1.json
  def update
    respond_to do |format|
      if @event.update(event_params)
        format.html { redirect_to @event, notice: 'Event was successfully updated.' }
        format.json { render :show, status: :ok, location: @event }
      else
        format.html { render :edit }
        format.json { render json: @event.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /events/1
  # DELETE /events/1.json
  def destroy
    @event.destroy
    respond_to do |format|
      format.html { redirect_to events_url, notice: 'Event was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_event
      @event = Event.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def event_params
      params.require(:event).permit(:event_id, :start_date, :end_date, :start_time, :end_time, :virtual_date, :status, :meta_event_id)
    end

    def date_param
      return params[:date] ? Date.strptime( params[:date], "%d/%m/%Y" ) : nil
    end
end

app/helpers/events_helper.rb
module EventsHelper
end

app/views/events/_form.html.erb
<%= form_for(@event) do |f| %>
  <% if @event.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@event.errors.count, "error") %> prohibited this event from being saved:</h2>

      <ul>
      <% @event.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :event_id %><br>
    <%= f.number_field :event_id %>
  </div>
  <div class="field">
    <%= f.label :start_date %><br>
    <%= f.date_select :start_date %>
  </div>
  <div class="field">
    <%= f.label :end_date %><br>
    <%= f.date_select :end_date %>
  </div>
  <div class="field">
    <%= f.label :start_time %><br>
    <%= f.time_select :start_time %>
  </div>
  <div class="field">
    <%= f.label :end_time %><br>
    <%= f.time_select :end_time %>
  </div>
  <div class="field">
    <%= f.label :virtual_date %><br>
    <%= f.date_select :virtual_date %>
  </div>
  <div class="field">
    <%= f.label :status %><br>
    <%= f.number_field :status %>
  </div>
  <div class="field">
    <%= f.label :meta_event_id %><br>
    <%= f.number_field :meta_event_id %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/events/edit.html.erb
<h1>Editing event</h1>

<%= render 'form' %>

<%= link_to 'Show', @event %> |
<%= link_to 'Back', events_path %>

app/views/events/index.html.erb
<h1>Listing events</h1>

<table>
  <thead>
    <tr>
      <th>Event</th>
      <th>Start Date</th>
      <th>End Date</th>
      <th>Start Time</th>
      <th>End Time</th>
      <th>Virtual Date</th>
      <th>Status</th>
      <th>Meta event</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @events.each do |event| %>
      <tr>
        <td><%= event.event_id %></td>
        <td><%= event.start_date %></td>
        <td><%= event.end_date %></td>
        <td><%= event.start_time %></td>
        <td><%= event.end_time %></td>
        <td><%= event.virtual_date %></td>
        <td><%= event.status %></td>
        <td><%= event.meta_event_id %></td>
        <td><%= link_to 'Show', event %></td>
        <td><%= link_to 'Edit', edit_event_path(event) %></td>
        <td><%= link_to 'Destroy', event, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Event', new_event_path %>

app/views/events/new.html.erb
<h1>New event</h1>

<%= render 'form' %>

<%= link_to 'Back', events_path %>

app/views/events/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Event:</strong>
  <%= @event.event_id %>
</p>

<p>
  <strong>Start Date:</strong>
  <%= @event.start_date %>
</p>

<p>
  <strong>End Date:</strong>
  <%= @event.end_date %>
</p>


<p>
  <strong>Start Time:</strong>
  <%= @event.start_time %>
</p>

<p>
  <strong>End Time:</strong>
  <%= @event.end_time %>
</p>

<p>
  <strong>Virtual date:</strong>
  <%= @event.virtual_date %>
</p>

<p>
  <strong>Status:</strong>
  <%= @event.status %>
</p>

<p>
  <strong>Meta event:</strong>
  <%= @event.meta_event_id %>
</p>

<%= link_to 'Edit', edit_event_path(@event) %> |
<%= link_to 'Back', events_path %>